package org.jeecg.modules.stm.projectbase.outsourcer.controller;

import java.util.Arrays;
import jakarta.servlet.http.HttpServletRequest;
import jakarta.servlet.http.HttpServletResponse;
import org.jeecg.common.api.vo.Result;
import org.jeecg.common.system.query.QueryGenerator;
import org.jeecg.modules.stm.projectbase.outsourcer.entity.StOutsourcerManage;
import org.jeecg.modules.stm.projectbase.outsourcer.service.IStOutsourcerManageService;

import com.baomidou.mybatisplus.core.conditions.query.QueryWrapper;
import com.baomidou.mybatisplus.core.metadata.IPage;
import com.baomidou.mybatisplus.extension.plugins.pagination.Page;
import lombok.extern.slf4j.Slf4j;

import org.jeecg.common.system.base.controller.JeecgController;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.*;
import org.springframework.web.servlet.ModelAndView;
 
 
import org.jeecg.common.aspect.annotation.AutoLog;
import org.apache.shiro.authz.annotation.RequiresPermissions;

/**
 * @Description: 外包商管理
 * @Author: jeecg-boot
 * @Date: 2023-08-12
 * @Version: V1.0
 */
  
@RestController
@RequestMapping("/projectbase.outsourcer/stOutsourcerManage")
@Slf4j
public class StOutsourcerManageController extends JeecgController<StOutsourcerManage, IStOutsourcerManageService> {
	@Autowired
	private IStOutsourcerManageService stOutsourcerManageService;

	/**
	 * 分页列表查询
	 *
	 * @param stOutsourcerManage
	 * @param pageNo
	 * @param pageSize
	 * @param req
	 * @return
	 */
	// @AutoLog(value = "外包商管理-分页列表查询")
	  
	@GetMapping(value = "/list")
	public Result<IPage<StOutsourcerManage>> queryPageList(StOutsourcerManage stOutsourcerManage,
			@RequestParam(name = "pageNo", defaultValue = "1") Integer pageNo,
			@RequestParam(name = "pageSize", defaultValue = "10") Integer pageSize, HttpServletRequest req) {
		QueryWrapper<StOutsourcerManage> queryWrapper = QueryGenerator.initQueryWrapper(stOutsourcerManage,
				req.getParameterMap());
		Page<StOutsourcerManage> page = new Page<StOutsourcerManage>(pageNo, pageSize);
		if (stOutsourcerManage.getOutsourcerName() != null) {
			queryWrapper.like("Outsourcer_Name", "%" + stOutsourcerManage.getOutsourcerName() + "%");
		}
		if (stOutsourcerManage.getOutsourcerClassify() != null) {
			queryWrapper.eq("Outsourcer_Classify", stOutsourcerManage.getOutsourcerClassify());
		}
		if (stOutsourcerManage.getStatus() != null) {
			queryWrapper.eq("status", stOutsourcerManage.getStatus());
		}
		queryWrapper.orderByDesc("created_Time");
		IPage<StOutsourcerManage> pageList = stOutsourcerManageService.page(page, queryWrapper);
		return Result.OK(pageList);
	}

	/**
	 * 添加
	 *
	 * @param stOutsourcerManage
	 * @return
	 */
	@AutoLog(value = "外包商管理-添加")
	  
	@RequiresPermissions("projectbase.outsourcer:st_outsourcer_manage:add")
	@PostMapping(value = "/add")
	public Result<String> add(@RequestBody StOutsourcerManage stOutsourcerManage) {
		stOutsourcerManageService.save(stOutsourcerManage);
		return Result.OK("添加成功！");
	}

	/**
	 * 编辑
	 *
	 * @param stOutsourcerManage
	 * @return
	 */
	@AutoLog(value = "外包商管理-编辑")
	  
	@RequiresPermissions("projectbase.outsourcer:st_outsourcer_manage:edit")
	@RequestMapping(value = "/edit", method = { RequestMethod.PUT, RequestMethod.POST })
	public Result<String> edit(@RequestBody StOutsourcerManage stOutsourcerManage) {
		stOutsourcerManageService.updateById(stOutsourcerManage);
		return Result.OK("编辑成功!");
	}

	/**
	 * 通过id删除
	 *
	 * @param id
	 * @return
	 */
	@AutoLog(value = "外包商管理-通过id删除")
	  
	@RequiresPermissions("projectbase.outsourcer:st_outsourcer_manage:delete")
	@DeleteMapping(value = "/delete")
	public Result<String> delete(@RequestParam(name = "id", required = true) String id) {
		stOutsourcerManageService.removeById(id);
		return Result.OK("删除成功!");
	}

	/**
	 * 批量删除
	 *
	 * @param ids
	 * @return
	 */
	@AutoLog(value = "外包商管理-批量删除")
	  
	@RequiresPermissions("projectbase.outsourcer:st_outsourcer_manage:deleteBatch")
	@DeleteMapping(value = "/deleteBatch")
	public Result<String> deleteBatch(@RequestParam(name = "ids", required = true) String ids) {
		this.stOutsourcerManageService.removeByIds(Arrays.asList(ids.split(",")));
		return Result.OK("批量删除成功!");
	}

	/**
	 * 通过id查询
	 *
	 * @param id
	 * @return
	 */
	// @AutoLog(value = "外包商管理-通过id查询")
	  
	@GetMapping(value = "/queryById")
	public Result<StOutsourcerManage> queryById(@RequestParam(name = "id", required = true) String id) {
		StOutsourcerManage stOutsourcerManage = stOutsourcerManageService.getById(id);
		if (stOutsourcerManage == null) {
			return Result.error("未找到对应数据");
		}
		return Result.OK(stOutsourcerManage);
	}

	/**
	 * 导出excel
	 *
	 * @param request
	 * @param stOutsourcerManage
	 */
	@RequiresPermissions("projectbase.outsourcer:st_outsourcer_manage:exportXls")
	@RequestMapping(value = "/exportXls")
	public ModelAndView exportXls(HttpServletRequest request, StOutsourcerManage stOutsourcerManage) {
		return super.exportXls(request, stOutsourcerManage, StOutsourcerManage.class, "外包商管理");
	}

	/**
	 * 通过excel导入数据
	 *
	 * @param request
	 * @param response
	 * @return
	 */
	@RequiresPermissions("projectbase.outsourcer:st_outsourcer_manage:importExcel")
	@RequestMapping(value = "/importExcel", method = RequestMethod.POST)
	public Result<?> importExcel(HttpServletRequest request, HttpServletResponse response) {
		return super.importExcel(request, response, StOutsourcerManage.class);
	}

}
